<?php if(!defined('PmWiki'))exit;
/**
	An AJAX based support for editing pages in PmWiki
	Written by (c) Esteve Boix 2009-2010

	This text is written for PmWiki; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published
	by the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version. See pmwiki.php for full details
	and lack of warranty.

	Copyright 2009-2010 Esteve Boix http://www.esteveb.com
*/
$RecipeInfo['AjaxEditSupport']['Version'] = '20091229';

# Tags added by this recipe
Markup('ajax-pages', 'directives',
    '/\\(:ajaxeditsupport\\s*(.*?):\\)/ei',
    "Keep(FmtAjaxEditSupport('$pagename',PSS('$1')))");

SDVA( $HandleActions, array(
    'ajaxeditsupport-pages' => 'HandleAjaxEditSupportPages',
    'ajaxeditsupport-attachments' => 'HandleAjaxEditSupportAttachments',
    'ajaxeditsupport-categories' => 'HandleAjaxEditSupportCategories',
    )
);

# pattern should be same as defined in markup
SDV($AjaxEditSupportTitlePattern,'/\\(:title\\s(.*?):\\)/i');

$isAjaxEditSupportJsLoaded=false;

function LoadAjaxEditSupportJs()
{
    global $isAjaxEditSupportJsLoaded,$PubDirUrl;
    $sid = session_id();
    @session_start();
    $_SESSION['ajaxeditsupport-cache']=array();

    if($isAjaxEditSupportJsLoaded==false)
    {
        $html='
        <style>
        <!--
            tr.aesentry:hover {background-color: #e0e0ee;}
        //-->
        </style>
        <script type="text/javascript" src="'.$PubDirUrl.'/ajaxeditsupport/jquery-1.3.2.min.js"></script>
        <script>
        <!--
        function openSupportWindow()
        {
            if($("#ajaxeditsupportPages").is(":visible"))
            {
                $("#ajaxeditsupportPages").hide();
                return;
            }
            displayPages("local");
        }
        function openSupportAttWindow()
        {
            if($("#ajaxeditsupportAttachments").is(":visible"))
            {
                $("#ajaxeditsupportAttachments").hide();
                return;
            }
            displayAttachments("viewfiles","");
        }
        function openSupportCatWindow()
        {
            if($("#ajaxeditsupportCategories").is(":visible"))
            {
                $("#ajaxeditsupportCategories").hide();
                return;
            }
            displayCategories();
        }

        function displayPages(mode,group)
        {
            $(document).ready(function(){
                $("#ajaxeditsupportAttachments").hide();
                $("#ajaxeditsupportCategories").hide();
                $("#ajaxeditsupportLoading").show();
                $.get("?action=ajaxeditsupport-pages", { aesmode: mode, group: group },
                    function(data){
                        $("#ajaxeditsupportPages").html(data);
                        $("#ajaxeditsupportLoading").hide();
                        $("#ajaxeditsupportPages").show();
                    });
             });
        }
        function displayAttachments(mode,element)
        {
            $(document).ready(function(){
                $("#ajaxeditsupportPages").hide();
                $("#ajaxeditsupportCategories").hide();
                $("#ajaxeditsupportAttLoading").show();
                $.get("?action=ajaxeditsupport-attachments", { aesmode: mode, element: element},
                    function(data){
                        $("#ajaxeditsupportAttachments").html(data);
                        $("#ajaxeditsupportAttLoading").hide();
                        $("#ajaxeditsupportAttachments").show();
                    });
             });
        }
        function displayCategories()
        {
            $(document).ready(function(){
                $("#ajaxeditsupportPages").hide();
                $("#ajaxeditsupportAttachments").hide();
                $("#ajaxeditsupportCatLoading").show();
                $.get("?action=ajaxeditsupport-categories", {},
                    function(data){
                        $("#ajaxeditsupportCategories").html(data);
                        $("#ajaxeditsupportCatLoading").hide();
                        $("#ajaxeditsupportCategories").show();
                    });
             });
        }
        function displayPageAttachments(element)
        {
            displayAttachments("viewfiles",element);
        }
        function insertLinkTo(page)
        {
            insMarkup("[["+page+"|", "]]", "Link name");
            $("#ajaxeditsupportPages").hide();
            $("#ajaxeditsupportAttachments").hide();
        }
        function insertCategory(category)
        {
            insMarkup("[[!"+category+"]]", "","");
            $("#ajaxeditsupportCategories").hide();
        }
        function insertAttachment(attachment)
        {
            insMarkup("Attach:"+attachment, "", "");
            $("#ajaxeditsupportAttachments").hide();
        }
        //-->
        </script>
        ';
        $isAjaxEditSupportJsLoaded=true;
        return $html;
    }
    if (!$sid) session_write_close();
    return "";
}

/**
 *  HTML code to display the list of available pages
 *      pagefilter
 */
function FmtAjaxEditSupport($pagename, $args)
{
    global $PubDirUrl;
    
    $parsedArgs=ParseArgs($args);
    $html = LoadAjaxEditSupportJs();
    $html.= '
        <br/>
        <span style="position:relative">
            <img src="'.$PubDirUrl.'/ajaxeditsupport/aes-links.gif" border="0" align="absmiddle"/><a href="#" onClick="openSupportWindow()">Pages</a>
            <div id="ajaxeditsupportPages" style="position:absolute;left:0px;top;20px;width:450px;height:300px;overflow:scroll;background:white;padding:5px;border:1px solid black;display:none;">
            </div>
            <div id="ajaxeditsupportLoading" style="position:absolute;left:0px;top;20px;height:300px;width:450px;background:white;display:none" align="center">
                <br/><br/><br/><br/><br/><br/><img src="'.$PubDirUrl.'/ajaxeditsupport/loader16.gif" width="16" height="16"/> Loading...
            </div>
        </span>
        <span style="position:relative">
            <img src="'.$PubDirUrl.'/ajaxeditsupport/aes-attach.gif" border="0" align="absmiddle"/><a href="#" onClick="openSupportAttWindow()">Attachments</a>
            <div id="ajaxeditsupportAttachments" style="position:absolute;left:0px;top;20px;width:450px;height:300px;overflow:scroll;background:white;padding:5px;border:1px solid black;display:none;">
            </div>
            <div id="ajaxeditsupportAttLoading" style="position:absolute;left:0px;top;20px;height:300px;width:450px;background:white;display:none" align="center">
                <br/><br/><br/><br/><br/><br/><img src="'.$PubDirUrl.'/ajaxeditsupport/loader16.gif" width="16" height="16"/> Loading...
            </div>
        </span>
        <span style="position:relative">
            <img src="'.$PubDirUrl.'/ajaxeditsupport/aes-categories.gif" border="0" align="absmiddle"/><a href="#" onClick="openSupportCatWindow()">Categories</a>
            <div id="ajaxeditsupportCategories" style="position:absolute;left:0px;top;20px;width:450px;height:300px;overflow:scroll;background:white;padding:5px;border:1px solid black;display:none;">
            </div>
            <div id="ajaxeditsupportCatLoading" style="position:absolute;left:0px;top;20px;height:300px;width:450px;background:white;display:none" align="center">
                <br/><br/><br/><br/><br/><br/><img src="'.$PubDirUrl.'/ajaxeditsupport/loader16.gif" width="16" height="16"/> Loading...
            </div>
        </span>';

    return $html;
}

/**
 * Retrieves a list of all the available pages/groups so that we can insert a link.
 * It expects the request to contain:
 *  'aesmode'=>local for current group, groups to list all the groups, or 'listgroup' to
 *             list an actual group.
 *  'group' => The group listed in 'listgroup'.
 * @param <type> $pagename
 * @param <type> $auth
 */
function HandleAjaxEditSupportPages($pagename,$auth='read')
{
    global $WikiDir,$UploadPrefixFmt,$AjaxEditSupportTitlePattern;
    $sid = session_id();
    @session_start();
    $groupPage=explode(".",$pagename);

    $pages=AjaxEditSupportGetFileList();
    $html="<a href=# onClick='displayPages(\"local\");'>This group</a> | <a href=# onClick='displayPages(\"groups\");'>List groups</a><hr size='1' color='black'/>";

    switch($_REQUEST['aesmode'])
    {
        case "local":
            if(isset($_SESSION['ajaxeditsupport-cache']['local']))
            {
                $htmlLocal=$_SESSION['ajaxeditsupport-cache']['local'];
            }
            else
            {
                $htmlLocal="Pages in this group ($groupPage[0]):<br/><table>";
                $htmlLocal.=AjaxEditSupportListLocalGroup($pages,$pagename,"insertLinkTo");
                $_SESSION['ajaxeditsupport-cache']['local']=$htmlLocal;
            }
            break;
        case "groups":
            if(isset($_SESSION['ajaxeditsupport-cache']['groups']))
            {
                $htmlLocal=$_SESSION['ajaxeditsupport-cache']['groups'];
            }
            else
            {
                $htmlLocal="Available groups:<br/>";
                $htmlLocal.=AjaxEditSupportListGroups($pages,$pagename,"displayPages");
            }
            break;
        case "listgroup":
            $htmlLocal.="Pages in group ".$_REQUEST['group'].":<br/><table>";
            $htmlLocal.=AjaxEditSupportListGroup($pages,$_REQUEST['group'],"insertLinkTo");
            break;
    }
    $html.=$htmlLocal;
    print($html);
    if (!$sid) session_write_close();
}


/**
 * Retrieves a list of all the available attachments so that we can insert a link.
 * It expects the request to contain:
 *  'aesmode'=>"viewfiles" to list the attachments of files for a given page, groups to list all the groups,
 *              or 'listgroup' to list an actual group, 'listpage' to list an actual page of a group.
 *  'element' => The group listed in 'listgroup', the page for 'listpage'.
 * @param <type> $pagename
 * @param <type> $auth
 */
function HandleAjaxEditSupportAttachments($pagename,$auth='read')
{
    global $UploadPrefixFmt;
    global $UploadDir, $UploadPrefixFmt, $UploadUrlFmt,
            $EnableUploadVersions, $EnableDirectDownload;


    $sid = session_id();
    @session_start();
    $groupPage=explode(".",$pagename);

    $pages=AjaxEditSupportGetFileList();
    $html="
        <a href=# onClick='displayAttachments(\"viewfiles\",\"\");'>This page</a>
        | <a href=# onClick='displayAttachments(\"listgroup\",\"\");'>Pages in this group</a>
        | <a href=# onClick='displayAttachments(\"groups\",\"\");'>List groups</a><hr size='1' color='black'/>";

    switch($_REQUEST['aesmode'])
    {
        case "viewfiles":
            if(isset($_SESSION['ajaxeditsupport-cache']['att-local']) && $_REQUEST['element']=="")
            {
                $htmlLocal=$_SESSION['ajaxeditsupport-cache']['att-local'];
            }
            else
            {
                if($_REQUEST['element']=="")
                {
                    $element=$pagename;
                }
                else
                {
                    $element=$_REQUEST['element'];
                }
                $htmlLocal=AjaxEditSupportListFiles($element,$pagename);
                if($_REQUEST['element']=="")
                {
                    $_SESSION['ajaxeditsupport-cache']['att-local']=$htmlLocal;
                }
            }
            break;
        case "groups":
            if(isset($_SESSION['ajaxeditsupport-cache']['groups-att']))
            {
                $htmlLocal=$_SESSION['ajaxeditsupport-cache']['groups-att'];
            }
            else
            {
                $htmlLocal="Available groups:<br/>";
                $htmlLocal.=AjaxEditSupportListGroups($pages, $pagename, "displayAttachments");
                $_SESSION['ajaxeditsupport-cache']['groups-att']=$htmlLocal;
            }
            break;
        case "listgroup":
            $htmlLocal="Pages in this group:<br/>";

            if($_REQUEST['element']=="")
            {
                $temp=explode(".",$pagename);
                $group=$temp[0];
            }
            else
            {
                $group=$_REQUEST['element'];
            }
            $htmlLocal.=AjaxEditSupportListGroup($pages, $group, "displayPageAttachments");
            $_SESSION['ajaxeditsupport-cache']['group-att']=$htmlLocal;
            break;
    }
    $html.=$htmlLocal;
    print($html);
    if (!$sid) session_write_close();
}
/**
 *
 * Retrieves a list of all the available Categories so that we can insert a link.
 * @param <type> $pagename
 * @param <type> $auth
 */
function HandleAjaxEditSupportCategories($pagename,$auth='read')
{
    global $CategoryGroup;
    $sid = session_id();
    @session_start();
    $groupPage=explode(".",$pagename);

    $pages=AjaxEditSupportGetFileList();
    $html="";

    $htmlLocal.="Available categories:<br/><table>";
    $htmlLocal.=AjaxEditSupportListGroup($pages,$CategoryGroup,"insertCategory",true);
    $html.=$htmlLocal;
    print($html);
    if (!$sid) session_write_close();
}

function AjaxEditSupportGetFileList()
{
    global $WikiDir;

    if(isset($_SESSION['ajaxeditsupport-cache']['list']))
    {
        $pages=$_SESSION['ajaxeditsupport-cache']['list'];
    }
    else
    {
        $pages=$WikiDir->ls();
        sort($pages);
        $_SESSION['ajaxeditsupport-cache']['list']=$pages;
    }
    return $pages;
}

function AjaxEditSupportListLocalGroup($pages,$page,$link)
{
    global $AjaxEditSupportTitlePattern;

    $groupPage=explode(".",$page);
    $groupNameLen=strlen($groupPage[0]);
    $html="";
    foreach($pages as $currentpage)
    {
        if(substr($currentpage,0,$groupNameLen)==$groupPage[0])
        {
            $rp=RetrieveAuthPage($currentpage, 'read');
            if ($AjaxEditSupportTitlePattern!="" && preg_match($AjaxEditSupportTitlePattern, $rp['text'], $matches))
            {
                $title = htmlentities($matches[1]);
            }
            else
            {
                $title = '';
            }
            $temp=explode(".",$currentpage);
            $html.="<tr class='aesentry'><td><a href=# onClick='$link(\"$temp[1]\")'>$temp[1]</a></td>";
            $html.=htmlentities($title)."&nbsp;</td>";
            $html.="</tr>";
        }
    }
    return "<table>$html</table>";


}

function AjaxEditSupportListGroups($pages,$page,$link)
{
    global $CategoryGroup;

    $groupPage=explode(".",$page);
    $groups=array();
    foreach($pages as $currentpage)
    {
        $temp=explode(".",$currentpage);
        if(!isset($groups[$temp[0]]) && $groupPage[0]!=$temp[0] && (isset($CategoryGroup) && $temp[0]!=$CategoryGroup))
            $groups[$temp[0]]="";
    }
    $html="";
    foreach($groups as $group=>$data)
    {
        $html.="<tr class='aesentry'><td><a href=# onClick='$link(\"listgroup\",\"$group\")'>$group</a></td></tr>";
    }
    return "<table>$html</table>";
}

function AjaxEditSupportListGroup($pages,$group,$link,$nameOnly=false)
{
    global $AjaxEditSupportTitlePattern;
    $groupNameLen=strlen($group);
    $html="";
    foreach($pages as $page)
    {
        if(substr($page,0,$groupNameLen)==$group)
        {
            $rp=RetrieveAuthPage($page, 'read');
            if ($AjaxEditSupportTitlePattern!="" && preg_match($AjaxEditSupportTitlePattern, $rp['text'], $matches))
            {
                $title = htmlentities($matches[1]);
            }
            else
            {
                $title = '';
            }

            if($nameOnly)
            {
                $finalPage=substr($page,$groupNameLen+1);
            }
            else
            {
                $finalPage=$page;
            }

            $html.="<tr class='aesentry'><td><a href=# onClick='$link(\"$finalPage\")'>$finalPage</a></td>";
            $html.="$title</td>";
            $html.="</tr>";
        }
    }
    return "<table>$html</table>";
}

function AjaxEditSupportListFiles($page,$currentpage)
{
    global $UploadDir,$UploadPrefixFmt,$PageUrl,$EnableDirectDownload;

    $htmlLocal="Attachments in page $page:<br/><table>";

    ## locations
    $pageurl = FmtPageName( '$PageUrl', $page );
    $uploaddir = FmtPageName( "$UploadDir$UploadPrefixFmt", $page);
    $uploadurl = FmtPageName(
        IsEnabled($EnableDirectDownload, 1) ? "$UploadUrlFmt$UploadPrefixFmt/" : "\$PageUrl?action=download&amp;upname=",
        $page);

    $dirp = @opendir($uploaddir);
    $noAttachedFiles="<tr><td>No attached files</td></tr>";
    if ($dirp)
    {
        $filelist = array();
        while (($file = readdir($dirp))!==false)
        {
            if ( $file{0} == '.' ) continue;
            $filelist[$file] = $file;
        }
        closedir($dirp);
        natcasesort($filelist);
        if(count($filelist)==0)
        {
            $htmlLocal.=$noAttachedFiles;
        }
        else
        {
            foreach($filelist as $file)
            {
                if($page==$currentpage)
                {
                    $attachfile=$file;
                }
                else
                {
                    $groupPageName=explode(".",$page);
                    $currentGroupPageName=explode(".",$currentpage);
                    if($groupPageName[0]==$currentGroupPageName[0])
                    {
                        $attachfile=$groupPageName[1]."/".$file;
                    }
                    else
                    {
                        $attachfile=$page."/".$file;
                    }
                }

                $htmlLocal.="<tr class='aesentry'>
                    <td><a href='".$uploadurl."$file' target='_blank'>$file</a></td>
                    <td><a href=# onClick='insertAttachment(\"$attachfile\")'>Insert</a></td>
                    <td><a href=# onClick='insertLinkTo(\"Attach:$attachfile\")'>As link</a></td>

                </tr>";
            }
        }
    }
    else
    {
        $htmlLocal.=$noAttachedFiles;
    }
    $htmlLocal.="</table>";
    return $htmlLocal;

}